package com.fp.persistence.pgeneral.trans;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTION */
@Entity(name = "TgeneTransaction")
@Table(name = "TGENETRANSACTION")
public class TgeneTransaction extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneTransaction
     */
    @EmbeddedId
    private TgeneTransactionKey pk;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    @Column(name = "NAME", nullable = true)
    /**
     * Nombre de la Transaccion
     */
    private String name;

    @Column(name = "PAGE", nullable = true)
    /**
     * Pagina que dispara el inicio de la transacion
     */
    private String page;

    @Column(name = "AUTOQUERY", nullable = true)
    /**
     * Indicador de si la transaccion debe consultarse automaticamente al ser llamada
     */
    private String autoquery;

    @Column(name = "INTERNAL", nullable = true)
    /**
     * Transaccion interna.  Las transacciones internas no se presentan en el menú.
     */
    private String internal;

    @Column(name = "IMMOBILIZATION", nullable = true)
    /**
     * Indica si la transacción es de cliente y afecta la fecha de ultimo movimiento de cuenta para inmovilizacion.
     */
    private String immobilization;

    @Column(name = "COMPLETETARIFFITEMS", nullable = true)
    /**
     * Indica que la transaccion completa rubros de impuestos, cargos, comisiones
     */
    private String completetariffitems;

    @Column(name = "FINANCIALPROCESS", nullable = true)
    /**
     * Indica si la transaccion, tiene definido procesos que se ejecutan, junto a la transaccion finanicera.
     */
    private String financialprocess;

    @Column(name = "MANAGECACHE", nullable = true)
    /**
     * Indica si el registro se almacena en cache del servidor de aplicaicones
     */
    private String managecache;

    @Column(name = "SIGNATURE", nullable = true)
    /**
     * Indica si se habilita la presentacion de la firma en la transaccion, ejemplo pago de cheques
     */
    private String signature;

    @Column(name = "INBOX", nullable = true)
    /**
     * Y indica que cuando se ejecuta la transaccion, se consulta informacion del indbox.
     */
    private String inbox;

    @Column(name = "MESSAGECODE", nullable = true)
    /**
     * Codigo de plantilla de mensajes
     */
    private Integer messagecode;

    @Column(name = "QUERYAGAIN", nullable = true)
    /**
     * Campo que indica si se debe realizar o no una consulta despues de un mantenimiento
     */
    private String queryagain;

    @Column(name = "QUERYCODE", nullable = true)
    /**
     * QUERYCODE
     */
    private String querycode;

    @Column(name = "BRANCHAMONG", nullable = true)
    /**
     * Indica si la transaccion genera intersucursales
     */
    private String branchamong;    

    @Column(name = "JSFPAGE", nullable = true)    
    /**
     * Pagina jsf
     */
    private String jsfpage;




    /** Contructor por defecto */
    public TgeneTransaction() {
    }

    /**
     * Contructor de TgeneTransaction
     * 
     * @param pPk Clave Primaria del entity
     */
    public TgeneTransaction(TgeneTransactionKey pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneTransaction
     */
    public static TgeneTransaction find(EntityManager pEntityManager, TgeneTransactionKey pKey) throws Exception {
        TgeneTransaction obj = pEntityManager.find(TgeneTransaction.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneTransaction
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneTransaction
     */
    public TgeneTransactionKey getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneTransaction
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransaction
     */
    public void setPk(TgeneTransactionKey pPk) {
        pk = pPk;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de name
     * 
     * @return valor de name
     */
    public String getName() {
        return name;
    }

    /**
     * Fija el valor de name
     * 
     * @param pName nuevo Valor de name
     */
    public void setName(String pName) {
        name = pName;
    }

    /**
     * Obtiene el valor de page
     * 
     * @return valor de page
     */
    public String getPage() {
        return page;
    }

    /**
     * Fija el valor de page
     * 
     * @param pPage nuevo Valor de page
     */
    public void setPage(String pPage) {
        page = pPage;
    }

    /**
     * Obtiene el valor de page
     * 
     * @return valor de page
     */
    public String getJsfpage() {
        return jsfpage;
    }

    /**
     * Fija el valor de page
     * 
     * @param pPage nuevo Valor de page
     */
    public void setJsfpage(String pJsfpage) {
        jsfpage = pJsfpage;
    }

    /**
     * Obtiene el valor de autoquery
     * 
     * @return valor de autoquery
     */
    public String getAutoquery() {
        return autoquery;
    }

    /**
     * Fija el valor de autoquery
     * 
     * @param pAutoquery nuevo Valor de autoquery
     */
    public void setAutoquery(String pAutoquery) {
        autoquery = pAutoquery;
    }

    /**
     * Obtiene el valor de internal
     * 
     * @return valor de internal
     */
    public String getInternal() {
        return internal;
    }

    /**
     * Fija el valor de internal
     * 
     * @param pInternal nuevo Valor de internal
     */
    public void setInternal(String pInternal) {
        internal = pInternal;
    }

    /**
     * Obtiene el valor de immobilization
     * 
     * @return valor de immobilization
     */
    public String getImmobilization() {
        return immobilization;
    }

    /**
     * Fija el valor de immobilization
     * 
     * @param pImmobilization nuevo Valor de immobilization
     */
    public void setImmobilization(String pImmobilization) {
        immobilization = pImmobilization;
    }

    /**
     * Obtiene el valor de completetariffitems
     * 
     * @return valor de completetariffitems
     */
    public String getCompletetariffitems() {
        return completetariffitems;
    }

    /**
     * Fija el valor de completetariffitems
     * 
     * @param pCompletetariffitems nuevo Valor de completetariffitems
     */
    public void setCompletetariffitems(String pCompletetariffitems) {
        completetariffitems = pCompletetariffitems;
    }

    /**
     * Obtiene el valor de financialprocess
     * 
     * @return valor de financialprocess
     */
    public String getFinancialprocess() {
        return financialprocess;
    }

    /**
     * Fija el valor de financialprocess
     * 
     * @param pFinancialprocess nuevo Valor de financialprocess
     */
    public void setFinancialprocess(String pFinancialprocess) {
        financialprocess = pFinancialprocess;
    }

    /**
     * Obtiene el valor de managecache
     * 
     * @return valor de managecache
     */
    public String getManagecache() {
        return managecache;
    }

    /**
     * Fija el valor de managecache
     * 
     * @param pManagecache nuevo Valor de managecache
     */
    public void setManagecache(String pManagecache) {
        managecache = pManagecache;
    }

    /**
     * Obtiene el valor de signature
     * 
     * @return valor de signature
     */
    public String getSignature() {
        return signature;
    }

    /**
     * Fija el valor de signature
     * 
     * @param pSignature nuevo Valor de signature
     */
    public void setSignature(String pSignature) {
        signature = pSignature;
    }

    /**
     * Obtiene el valor de inbox
     * 
     * @return valor de inbox
     */
    public String getInbox() {
        return inbox;
    }

    /**
     * Fija el valor de inbox
     * 
     * @param pInbox nuevo Valor de inbox
     */
    public void setInbox(String pInbox) {
        inbox = pInbox;
    }

    /**
     * Obtiene el valor de messagecode
     * 
     * @return valor de messagecode
     */
    public Integer getMessagecode() {
        return messagecode;
    }

    /**
     * Fija el valor de messagecode
     * 
     * @param pMessagecode nuevo Valor de messagecode
     */
    public void setMessagecode(Integer pMessagecode) {
        messagecode = pMessagecode;
    }

    /**
     * Obtiene el valor de queryagain
     * 
     * @return valor de queryagain
     */
    public String getQueryagain() {
        return queryagain;
    }

    /**
     * Fija el valor de queryagain
     * 
     * @param pQueryagain nuevo Valor de queryagain
     */
    public void setQueryagain(String pQueryagain) {
        queryagain = pQueryagain;
    }

    /**
     * Obtiene el valor de querycode
     * 
     * @return valor de querycode
     */
    public String getQuerycode() {
        return querycode;
    }

    /**
     * Fija el valor de querycode
     * 
     * @param pQuerycode nuevo Valor de querycode
     */
    public void setQuerycode(String pQuerycode) {
        querycode = pQuerycode;
    }

    /**
     * Obtiene el valor de branchamong
     * 
     * @return valor de branchamong
     */
    public String getBranchamong() {
        return branchamong;
    }

    /**
     * Fija el valor de branchamong
     * 
     * @param pBranchamong nuevo Valor de branchamong
     */
    public void setBranchamong(String pBranchamong) {
        branchamong = pBranchamong;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null)
            return false;
        if (!(rhs instanceof TgeneTransaction))
            return false;
        TgeneTransaction that = (TgeneTransaction) rhs;
        if (this.getPk() == null || that.getPk() == null)
            return false;
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementacion del metodo hashCode de la la entidad TgeneTransaction
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementacion toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0)
                    continue;
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
                    continue;
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementacion de la creacion de un bean en blanco TgeneTransaction */
    @Override
    public Object createInstance() {
        TgeneTransaction instance = new TgeneTransaction();
        instance.setPk(new TgeneTransactionKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneTransaction
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneTransaction p = (TgeneTransaction) this.clone();
        p.setPk((TgeneTransactionKey) this.pk.cloneMe());
        return p;
    }
}
